VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Object = "{648A5603-2C6E-101B-82B6-000000000014}#1.1#0"; "MSCOMM32.OCX"
Begin VB.Form frmFlash 
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "PIC Flasher"
   ClientHeight    =   2055
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5955
   Icon            =   "frmFlash.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2055
   ScaleWidth      =   5955
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton BtnExit 
      Caption         =   "Exit"
      Height          =   375
      Left            =   2760
      TabIndex        =   9
      Top             =   600
      Width           =   735
   End
   Begin VB.ComboBox CMBPortSpeed 
      Height          =   315
      Left            =   4680
      TabIndex        =   8
      Top             =   600
      Width           =   1215
   End
   Begin VB.ComboBox CmbCommSelect 
      Height          =   315
      Left            =   3600
      TabIndex        =   7
      Top             =   600
      Width           =   975
   End
   Begin MSCommLib.MSComm MSComm1 
      Left            =   4920
      Top             =   600
      _ExtentX        =   1005
      _ExtentY        =   1005
      _Version        =   393216
      DTREnable       =   -1  'True
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   120
      MultiLine       =   -1  'True
      TabIndex        =   5
      Top             =   1560
      Width           =   5775
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   5640
      Top             =   0
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.CommandButton Cmd_Openfile 
      Caption         =   "Open File"
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   600
      Width           =   975
   End
   Begin VB.CommandButton CMD_Flash_Cancel 
      Caption         =   "Cancel"
      Height          =   375
      Left            =   1920
      TabIndex        =   3
      Top             =   600
      Width           =   855
   End
   Begin VB.CommandButton CMD_Flash_OK 
      Caption         =   "Update"
      Height          =   375
      Left            =   1080
      TabIndex        =   2
      Top             =   600
      Width           =   855
   End
   Begin VB.TextBox txt_Filename 
      Height          =   375
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   5775
   End
   Begin MSComctlLib.ProgressBar ProgressBar1 
      Height          =   375
      Left            =   120
      TabIndex        =   0
      Top             =   1080
      Width           =   4695
      _ExtentX        =   8281
      _ExtentY        =   661
      _Version        =   393216
      Appearance      =   1
   End
   Begin VB.Label Label2 
      Height          =   375
      Left            =   5040
      TabIndex        =   6
      Top             =   1080
      Width           =   855
   End
End
Attribute VB_Name = "frmFlash"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim UpdateCancelled As Boolean
Dim XON_Received As Boolean
Dim XOFF_Received As Boolean
Dim ACK_Received As Boolean
Dim ComPorts(1 To 16) As Boolean
Private Declare Function GetTickCount Lib "kernel32" () As Long ' used in the slowdown routine

Private Sub BtnExit_Click()
If MSComm1.PortOpen = True Then
    MSComm1.PortOpen = False
End If
Unload Me
End Sub

Private Sub Form_Load()
Dim PortSpeed
Dim COMPORT

Text1.Text = ""
Call Populate_Commports
Call Populate_PortSpeed
COMPORT = GetSetting("KMP Engineering", "AutoSaveSettings", "Com_Port", "")
If COMPORT <> "" Then
MSComm1.CommPort = COMPORT
End If
CmbCommSelect.Text = "COM" & MSComm1.CommPort
    MSComm1.InputLen = 1
    MSComm1.RThreshold = 1
PortSpeed = GetSetting("KMP Engineering", "AutoSaveSettings", "PortSpeed", "")
If PortSpeed <> "" Then
    Call DisplaySpeed(PortSpeed)
    'CMBPortSpeed.Text = PortSpeed & "bps"
    MSComm1.Settings = PortSpeed
Else
    CMBPortSpeed.Text = "600bps"
    MSComm1.Settings = "600,n,8,1"
End If

End Sub
Private Sub DisplaySpeed(speed)
Select Case speed
         Case "600,n,8,1"
          CMBPortSpeed.Text = "600bps"
         Case "1200,n,8,1"
          CMBPortSpeed.Text = "1200bps"
         Case "2400,n,8,1"
           CMBPortSpeed.Text = "2400bps"
         Case "4800,n,8,1"
          CMBPortSpeed.Text = "4800bps"
         Case "9600,n,8,1"
          CMBPortSpeed.Text = "9600bps"
         Case "19200,n,8,1"
          CMBPortSpeed.Text = "19200bps"
         Case "38400,n,8,1"
          CMBPortSpeed.Text = "38400bps"
         Case "57600,n,8,1"
          CMBPortSpeed.Text = "57600bps"
         Case "115200,n,8,1"
         CMBPortSpeed.Text = "115200bps"
       End Select
End Sub
Private Sub Populate_PortSpeed()
' adding valid com port speeds to the lineup
CMBPortSpeed.AddItem "600bps"
CMBPortSpeed.AddItem "1200bps"
CMBPortSpeed.AddItem "2400bps"
CMBPortSpeed.AddItem "4800bps"
CMBPortSpeed.AddItem "9600bps"
CMBPortSpeed.AddItem "19200bps"
CMBPortSpeed.AddItem "38400bps"
CMBPortSpeed.AddItem "57600bps"
CMBPortSpeed.AddItem "115200bps"

End Sub


Private Sub Populate_Commports()
Dim i As Integer
On Error Resume Next
 CmbCommSelect.Clear
For i = 1 To 8
  MSComm1.CommPort = i
  MSComm1.PortOpen = True
 If Err Then
    ComPorts(i) = False
    Debug.Print "Commport " & i & " Not Available  "
    Err = 0
 Else
    ComPorts(i) = True
    Debug.Print "Commport " & i & " Available  "
    CmbCommSelect.AddItem "COM" & i
    MSComm1.PortOpen = False
 End If
If (MSComm1.PortOpen = True) Then MSComm1.PortOpen = False
Next i
End Sub
Private Sub CmbCommSelect_click()

On Error GoTo Errorhandler
    
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
  
    Select Case CmbCommSelect.Text
         Case "COM1"
           MSComm1.CommPort = 1
         Case "COM2"
           MSComm1.CommPort = 2
         Case "COM3"
           MSComm1.CommPort = 3
         Case "COM4"
           MSComm1.CommPort = 4
         Case "COM5"
           MSComm1.CommPort = 5
         Case "COM6"
           MSComm1.CommPort = 6
         Case "COM7"
           MSComm1.CommPort = 7
         Case "COM8"
           MSComm1.CommPort = 8
         Case Else
           MSComm1.PortOpen = False
    End Select
    SaveSetting "KMP Engineering", "AutoSaveSettings", "Com_Port", MSComm1.CommPort
    MSComm1.PortOpen = True
Exit Sub
Errorhandler:
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
    MsgBox ("Port is in use, or not present, Please select another one")
    SaveSetting "KMP Engineering", "AutoSaveSettings", "Com_Port", ""
    MSComm1.PortOpen = True
    Exit Sub
End Sub

Private Sub CMBPortSpeed_click()
On Error GoTo Errorhandler
    
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
 
    Select Case CMBPortSpeed.Text
         Case "600bps"
           MSComm1.Settings = "600,n,8,1"
         Case "1200bps"
           MSComm1.Settings = "1200,n,8,1"
         Case "2400bps"
           MSComm1.Settings = "2400,n,8,1"
         Case "4800bps"
           MSComm1.Settings = "4800,n,8,1"
         Case "9600bps"
           MSComm1.Settings = "9600,n,8,1"
         Case "19200bps"
           MSComm1.Settings = "19200,n,8,1"
         Case "38400bps"
           MSComm1.Settings = "38400,n,8,1"
         Case "57600bps"
           MSComm1.Settings = "57600,n,8,1"
         Case "115200bps"
           MSComm1.Settings = "115200,n,8,1"
         Case Else
           MSComm1.PortOpen = False
    End Select
    SaveSetting "KMP Engineering", "AutoSaveSettings", "PortSpeed", MSComm1.Settings
    MSComm1.PortOpen = True
Exit Sub
Errorhandler:
    If MSComm1.PortOpen = True Then MSComm1.PortOpen = False
    MsgBox ("Port is in use, or not present, Please select another one")
    SaveSetting "KMP Engineering", "AutoSaveSettings", "Com_Port", ""
    MSComm1.PortOpen = True
    Exit Sub
End Sub

Private Sub CMD_Flash_Cancel_Click()
UpdateCancelled = True
End Sub

Private Sub CMD_Flash_OK_Click()
If txt_Filename.Text <> "" Then
        Call OpenFile
   End If
End Sub

Private Sub Cmd_Openfile_Click()

   CommonDialog1.Filter = "Data Files (*.HEX)|*.HEX|"
   CommonDialog1.FilterIndex = 1                    ' Specify default filter.
   CommonDialog1.ShowOpen                           ' Display the Open dialog box.
   txt_Filename.Text = CommonDialog1.FileName         ' Call the open file procedure.
   frmFlash.Caption = "PIC Flasher - " & txt_Filename.Text
   
   
End Sub
Private Sub OpenFile()

'On Error GoTo Errorhandler
Dim fnum As Integer
Dim file_name As String
Dim file_record As String * 1
Dim MyString As String
Dim lSizeCount As Long
Dim lFileLen As Long
lSizeCount = 0
ProgressBar1.Max = 100

file_name = txt_Filename.Text                   ' Get the file name.
fnum = FreeFile                                     ' Open the file.
Open file_name For Input As #fnum

lFileLen = LOF(fnum) ' get the length of the file

If MSComm1.PortOpen = False Then
    MSComm1.PortOpen = True
End If
CmbCommSelect.Enabled = False
CMBPortSpeed.Enabled = False
UpdateCancelled = False
' my PIC when receiving STX,R, sets a flag in the eeprom and resets the CPU.
' The Bootloader then sees the flag is set and enters bootloading mode

MSComm1.Output = Chr$(2) & "R"  'Resets CPU and puts it in bootload mode
        SlowDown (500)          'This allows the PIC to be rebooted and ready for action :)
Do Until EOF(fnum)
        If UpdateCancelled = True Then
            Call Close_Files
            Exit Sub
        End If
        
        XON_Received = False
        ACK_Received = False
        Line Input #fnum, MyString
        Text1.Text = MyString
        MSComm1.Output = MyString & Chr$(13)
        Counter = Timer + 2 ' 2 second timeout
        lSizeCount = lSizeCount + Len(MyString) + 2 ' count the number of characters processed
        Do While ACK_Received = False                       ' wait for the ACK from the PIC
         If Int(100 * (lSizeCount / lFileLen)) = 100 Then   ' The bootloader does not send an ACK after the last line
            MsgBox "Flash Complete.", vbInformation
            Call Close_Files
            Exit Sub
         End If
            If Timer > Counter Then
               Call Close_Files
               MsgBox "Timeout!, Writing PIC  Please check the cable and try again", vbCritical, "Timeout"
                Exit Sub
            End If
            DoEvents
        Loop
        ProgressBar1.Value = Int(lSizeCount * 100 / lFileLen)  ' set the progressbar
        Label2.Caption = Int(100 * (lSizeCount / lFileLen)) & "% Done"
        frmFlash.Caption = "PIC Flasher -  " & txt_Filename.Text & " - " & Int(100 * (lSizeCount / lFileLen)) & "%"
        Counter = Timer + 2 ' 2 second timeout
        DoEvents
    Loop
MSComm1.PortOpen = False
Exit Sub
Errorhandler:                                       ' if any unspecified error has occured, show in messagebox
    MsgBox "OpenFile " & Err.Description & vbCrLf & "Error Number: " & Err.Number, vbExclamation, "Please email detectag with the error number kasper@detectag.com"
    Exit Sub
End Sub
Private Sub Close_Files()
                Close #fnum          ' close the file
                ProgressBar1.Value = 0
                Label2.Caption = ""
                frmFlash.Caption = "PIC Flasher - " & txt_Filename.Text
                Text1.Text = ""
                CmbCommSelect.Enabled = True
                CMBPortSpeed.Enabled = True
                CmbCommSelect.Enabled = True
              '  If MSComm1.PortOpen = True Then
              '      MSComm1.PortOpen = False
              '  End If
                
                
End Sub
Private Sub MSComm1_OnComm()
On Error GoTo Errorhandler

Select Case MSComm1.CommEvent
    Case comEventBreak   ' A Break was received.
    Case comEventCDTO    ' CD (RLSD) Timeout.
    Case comEventCTSTO   ' CTS Timeout.
    Case comEventDSRTO   ' DSR Timeout.
    Case comEventFrame   ' Framing Error.
    Case comEventOverrun ' Data Lost.
    Case comEventRxOver  ' Receive buffer overflow.
    Case comEventRxParity   ' Parity Error.
    Case comEventTxFull  ' Transmit buffer full.
    Case comEventDCB     ' Unexpected error retrieving DCB]
    Case comEvCD   ' Change in the CD line.
    Case comEvCTS  ' Change in the CTS line.
    Case comEvCTS
    Case comEvDSR  ' Change in the DSR line.
    Case comEvRing ' Change in the Ring Indicator.
    Case comEvReceive ' Received RThreshold # of chars.
        Call ReceiveHandeler
    Case comEvSend ' There are SThreshold number of
                            ' characters in the transmit buffer.
    Case comEvEOF  ' An EOF character was found in the
                           ' input stream.
    Case comCTSTO                   'CTS timeout
    
    Case comRTSTO
 
    End Select
     
 Exit Sub
Errorhandler:
MsgBox "MSComm1_OnComm()!" & Err.Description & vbCrLf & "Error Number: " & Err.Number, vbExclamation, "Please email detectag with the error number kasper@detectag.com"

End Sub
Private Sub ReceiveHandeler()
Dim RX
RX = MSComm1.Input
'Debug.Print RX
Select Case RX
Case Chr$(2)        'STX
                 '   Debug.Print "STX"
Case Chr$(10)
             
Case Chr$(17)
                XON_Received = True
                Debug.Print "XON"
Case Chr$(19)
                XOFF_Received = True
                Debug.Print "XOFF"
Case Chr$(6)
                ACK_Received = True
                Debug.Print "ACK"
              
Case Else

End Select

End Sub

Public Sub SlowDown(MilliSeconds As Long)

Dim lngTickStore As Long

lngTickStore = GetTickCount()

Do While lngTickStore + MilliSeconds > GetTickCount()
DoEvents
Loop

End Sub
